/* $Id: config.h,v 1.1 2002/08/28 23:12:42 drh Exp $ */
typedef struct {
	unsigned char max_unaligned_load;
	Symbol (*rmap)(long);

	void (*blkfetch)(long size, long off, long reg, long tmp);
	void (*blkstore)(long size, long off, long reg, long tmp);
	void (*blkloop)(long dreg, long doff,
	                 long sreg, long soff,
	                 long size, long tmps[]);
	void (*_label)(Node);
	int (*_rule)(void*, int);
	short **_nts;
	void (*_kids)(Node, int, Node*);
	char **_string;
	char **_templates;
	char *_isinstruction;
	char **_ntname;
	void (*emit2)(Node);
	void (*doarg)(Node);
	void (*target)(Node);
	void (*clobber)(Node);
} Xinterface;
extern long     askregvar(Symbol, Symbol);
extern void    blkcopy(long, long, long, long, long, long[]);
extern unsigned emitasm(Node, long);
extern long     getregnum(Node);
extern long     mayrecalc(Node);
extern long     mkactual(long, long);
extern void    mkauto(Symbol);
extern Symbol  mkreg(char *, long, long, long);
extern Symbol  mkwildcard(Symbol *);
extern long     move(Node);
extern long     notarget(Node);
extern void    parseflags(long, char **);
extern long     range(Node, long long, long long);
extern unsigned regloc(Symbol);  /* omit */
extern void    rtarget(Node, long, Symbol);
extern void    setreg(Node, Symbol);
extern void    spill(unsigned, long, Node);
extern long     widens(Node);

extern long      argoffset, maxargoffset;
extern long      bflag, dflag;
extern long      dalign, salign;
extern long      framesize;
extern unsigned freemask[], usedmask[];
extern long      offset, maxoffset;
extern long      swap;
extern unsigned tmask[], vmask[];
typedef struct {
	unsigned listed:1;
	unsigned registered:1;
	unsigned emitted:1;
	unsigned copy:1;
	unsigned equatable:1;
	unsigned spills:1;
	unsigned mayrecalc:1;
	void *state;
	short inst;
	Node kids[3];
	Node prev, next;
	Node prevuse;
	short argno;
} Xnode;
typedef struct {
	Symbol vbl;
	short set;
	short number;
	unsigned mask;
} *Regnode;
enum { IREG=0, FREG=1 };
typedef struct {
	char *name;
	unsigned long eaddr;  /* omit */
	long offset;
	Node lastuse;
	long usecount;
	Regnode regnode;
	Symbol *wildcard;
} Xsymbol;
enum { RX=2 };
typedef struct {
	long offset;
	unsigned freemask[2];
} Env;

#define LBURG_MAX SHRT_MAX

enum { VREG=(44<<4), ASM1=(46<<4), ASM2=(47<<4), ASMRET=(48<<4) };

/* Exported for the front end */
extern void             blockbeg(Env *);
extern void             blockend(Env *);
extern void             emit(Node);
extern Node             gen(Node);

extern unsigned         emitbin(Node, long);

//#define NDEBUG
#ifdef NDEBUG
#define debug(x) (void)0
#else
#define debug(x) (void)(dflag&&((x),0))
#endif

extern char WDbuf[8192];
void WriteDebug(char *wdstr);
